//"Wind" effect.  I think twisters are wind.
#define NUMBER 1000

#include <windows.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glaux.h>
#include <math.h>

typedef struct									// Create A Structure
{
	GLubyte	*imageData;							// Image Data (Up To 32 Bits)
	GLuint	bpp;								// Image Color Depth In Bits Per Pixel.
	GLuint	width;								// Image Width
	GLuint	height;								// Image Height
	GLuint	texID;								// Texture ID Used To Select A Texture
} TextureImage;	

TextureImage Tex[2];
float xposition;
float fincriment;

float GetAngleturn(void);
float GetAngleUp(void);
bool LoadTGA(TextureImage *texture, char *filename);
float GetFrameInterval(void);
void SetWindSoundPosition(float x, float y, float z);
void PlayWindSound(void);
typedef struct _dirt
{
	float radius;
	float theincriment;
	float y;
	float theangle;

}DIRT,*PTR_DIRT;

DIRT dirt[NUMBER];
float angle2;

void InitTwister(void)
{
	int counter;
	float countradius,countangle,county;
	countradius = 0.0f;
	countangle = 0.0f;
	county = 0.0f;
	for (counter = 0; counter < NUMBER; counter++)
	{
		dirt[counter].radius = countradius;
		dirt[counter].theangle = countangle;
		dirt[counter].y = 35 + county;
		countradius = countradius + 0.15f;
		countangle = countangle + 2.8f;
		county = county + 0.4f;
	
	}	
angle2 = 0; 
xposition = 0;
fincriment = -1.0f;
LoadTGA(&Tex[0],"boom.tga");
}



void DoTwister(void)
{
	
	glBindTexture(GL_TEXTURE_2D,Tex[0].texID);
	glColor3f(1,1,1);
	
	int counter;
	xposition = xposition + (50.0f * GetFrameInterval() * fincriment);// * GetFrameInterval() ); //*  GetFrameInterval() );
	
	if (xposition > 5000 || xposition < -500)
	{
		fincriment = -fincriment;
	} 
	SetWindSoundPosition(xposition,0,0);
	PlayWindSound();
	for (counter = 0; counter < NUMBER; counter++)
	{
	
	glPushMatrix();
	
	

	//location of twister on map itself..
	glTranslatef(xposition,dirt[counter].y,0);
	//SetWindSoundPosition(xposition,dirt[counter].y,0);
	//SetWindSoundPosition(0,0,0); 
	//set this back to zero maybe..
	//PlayWindSound();
	
	//if the twister gets out of place turn it around..
	/*if (xposition < 1000 || xposition > 0)
	{
		fincriment = -fincriment; 
	} */




	angle2 = angle2 + 1.0f;


	glPushMatrix();
	glRotatef(dirt[counter].theangle,0,1,0);
	glTranslatef(dirt[counter].radius,0,0);

	//bill boarding here
	glRotatef(GetAngleturn(),0,1,0);
	glRotatef(GetAngleUp(),1,0,0);
	
	glBegin(GL_QUADS);
		
		glTexCoord2f(0,0);
		glVertex3f(0,0,0);
		glTexCoord2f(1,0);
		glVertex3f(0,3,0);
		glTexCoord2f(1,1);
		glVertex3f(3,3,0);
		glTexCoord2f(0,1);
		glVertex3f(3,0,0);


		/*glTexCoord2f(0,0);
		glVertex3f(0,0,0);
		glTexCoord2f(1,0);
		glVertex3f(0,3,0);
		glTexCoord2f(1,1);
		glVertex3f(0,3,-3);
		glTexCoord2f(0,1);
		glVertex3f(0,0,-3);


		glTexCoord2f(0,0);
		glVertex3f(0,0,0);
		glTexCoord2f(1,0);
		glVertex3f(0,0,-3);
		glTexCoord2f(1,1);
		glVertex3f(3,0,-3);
		glTexCoord2f(0,1);
		glVertex3f(3,0,0); */


	glEnd();
	
	
	glPopMatrix();
	glPopMatrix();
	
	dirt[counter].theangle = dirt[counter].theangle + (rand()%3 + 2.8f * GetFrameInterval() * 20);//2.8f;
	dirt[counter].y = dirt[counter].y + (0.4f * GetFrameInterval() * 20);//(rand()%10 / 10.0f);//0.4f;
	dirt[counter].radius = dirt[counter].radius + (0.05f * GetFrameInterval() * 20);


	if (dirt[counter].radius > 100.99f)
	{
		dirt[counter].radius = 0;
		dirt[counter].y = 35.0f;
		dirt[counter].theangle = 0;
	}

	}//end for loop.





}
